unit KZVolInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TKZVolInfo = class(TComponent)
  private
    FSerialNumber:string;
    FDriveLetter:Char;
    FDriveName:String;
  protected
  public
    constructor Create(AOwner:TComponent);override;
    Procedure Execute;
  published
    property Drive:Char read FDriveLetter write FDriveLetter;
    property SerialNumber:String read FSerialNumber;
    property DriveName:string read FDriveName;
  end;

procedure Register;

implementation

constructor TKZVolInfo.Create(AOwner:TComponent);
begin
     inherited Create(AOwner);
     FDriveLetter:='c';
end;
Procedure TKZVolInfo.Execute;
var
   SerialNum : pdword;
   a, b : dword;
   s1:string;
   Buffer : array [0..255] of char;
begin
  if GetVolumeInformation(
        PChar(FDriveLetter+':\'),
        Buffer,
        SizeOf(Buffer),
        SerialNum,
        a,
        b,
        nil,
        0)
     then
         begin
              setstring(s1,buffer,strlen(buffer));
              FSerialNumber:=IntToHex(SerialNum^,8);
              FDriveName:=s1;
         end;
end;

procedure Register;
begin
  RegisterComponents('KireZ', [TKZVolInfo]);
end;

end.
